% calc_sparm.m
% 
% sws 9/2002
% 
% Script written to be accessed by CST MWS via a VBA macro.
% This script windows the time domain signals according to the 
% specified new time stop, then performs neccecary FFT's to find 
% the resulting S-parameters.
% 
% uses nearest.m and matlab_fft.m

%set up
Nsamp = sendA(1);
Fmin = sendA(2);
Fmax = sendA(3);

%find Tstop in array
indA=nearest(time,tstop);

%window time waveforms
timeW=time(1:indA);
sig_inW=sig_in(1:indA);
sig_outW=sig_out(1:indA);

%desired frequency points
freqD=linspace(Fmin,Fmax,Nsamp);

%estimate how much zero padding is needed to output Nsamp in freq range
dt=timeW(2)-timeW(1);		    %sampling interval
df=(freqD(2)-freqD(1));   %required df
Npad=ceil(1/dt/df);	                %find Npad

%take fft of time signals using sws_fft.m
[Yin,fin]=matlab_fft(sig_inW,timeW,Npad);
[Yout,fin]=matlab_fft(sig_outW,timeW,Npad);

%compute S-parameters
S11R=Yout./Yin;

%limit freq spectrum
S11D=interp1(fin,S11R,freqD,'cubic');
S11dBD=20.*log10(abs(S11D));

%adjust size for return to MWS
freqD=freqD';
S11dBD=S11dBD';

%plot(freqD,20.*log10(abs(S11_W)));grid on;



