%function [Y,f] = matlab_fft(signal,time,N)
%	function written to transform data taken from LC to the frequency domain.
%	Input: 	signal & time are M X 1 matrices
%           N is an integer, where the signal is padded or truncated to match N samples
%	Output: Complex [Y], and frequency [f] of spectum centered aound D.C. 
function [Y,f] = sws_fft(signal,time,N)

%-----------------------------------------------------------------------------------------
y=fft(signal,N);			%take fft transform
m=(y);					%mag of fft
dt=time(2)-time(1);			%sampling interval
T=length(time)*dt;			%record length
f=(0:length(y)-1)'*(1/dt/length(y));	%find freq range
Y=fftshift(m)./length(signal);		%center around DC and scale Y
f=f-mean(f);                            %center freq